/* =================================================================================================
Listing 1.  Heart Rate Monitoring Program.
By Bryan Bergeron
For Nuts & Volts Magazine
Accompanys my article "Basic Biological Signal Monitoring – With a Translational Reality Twist"
Grove heart beat monitor clip on D2.
LEDs on D4, 5, and 6.
=================================================================================================== */

#define Clip 2                            
#define SlowLED 4                              
#define ZoneLED 5 
#define FastLED 6 

unsigned long ZoneLow = 0;
unsigned long ZoneHigh = 0;    
unsigned long previousMillis = 0;
unsigned long currentMillis = 0;
unsigned long Interval = 0;
unsigned long currentInterval = 0;
unsigned long previousInterval = 0;
const long minInterval = 300;  // 200 bpm = 300 ms
const long maxInterval = 1200;  // 50 bpm = 1200 ms

void setup() {
  Serial.begin(9600);                    
  pinMode(Clip, INPUT);                  
  pinMode(SlowLED, OUTPUT);     
  pinMode(ZoneLED, OUTPUT); 
  pinMode(FastLED, OUTPUT);   
  ZoneLow = 860;    // 70 bpm - modify to fit your needs
  ZoneHigh = 600;   // 100 bpm        
}

void loop() {
  if(digitalRead(Clip)>0){        //sensor triggers HIGH on heart beat
    unsigned long currentMillis = millis();
    currentInterval = currentMillis - previousMillis;
    if (currentInterval > minInterval) {
      previousMillis = currentMillis;
      Interval = (previousInterval + currentInterval)/2;
      previousInterval = Interval;
          Serial.println(Interval);
      if (Interval < ZoneHigh){
        digitalWrite(FastLED, HIGH);  //RED - too fast!
        digitalWrite(ZoneLED, LOW);
        digitalWrite(SlowLED, LOW);
      }else{
        if (Interval > ZoneLow){
        digitalWrite(FastLED, LOW);
        digitalWrite(ZoneLED, LOW);
        digitalWrite(SlowLED, HIGH); //WHITE - pick up the pace!
        }else{
        digitalWrite(FastLED, LOW);
        digitalWrite(ZoneLED, HIGH); //GREEN - in the zone!
        digitalWrite(SlowLED, LOW);
        }
     }     
   }
  }
}  

